/*

   nas2unv ver 0.5 2001.02.27
   designed by Yuuki Nagashima, vq8y-ngsm@asahi-net.or.jp

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>


/* ----------------------------- */
struct RBVector
{
   double lRB1,mRB1,nRB1;
   double lRB2,mRB2,nRB2;
   double lRB3,mRB3,nRB3;
};
struct CVector
{
   double x[5],y[5],z[5];
};
/* ----------------------------- */


/*------------------------------------------------------------------Хѿ*/
/*----------------------------GRID ID,ɽɸڤӺɸ*/
int *id=NULL,*ic1=NULL,*ic2=NULL;
double *x=NULL,*y=NULL,*z=NULL;

/*---------Ǥproperty,material ID,Ǥμڤӥơ֥*/
int *mid=NULL,*pid=NULL,*iej=NULL;
int (*ie)[9]=NULL;

/*------------------------------------------ɽɸϤ*/
#define MAXCORDID 1000
#define type_cartesian 1
#define type_cylinder 2
int *cid=NULL,*ic3=NULL,*ctype=NULL,*i_c_chgd=NULL;
struct CVector *c_cvec=NULL;
struct RBVector *c_rvec=NULL;

/*--------------------------------------propertyڤmaterial*/
int *prop_id=NULL,*prop_mid=NULL,*piej=NULL;
double *prop_thk=NULL;
int *mat_id=NULL;
double *mat_e=NULL;
int *p_taiou=NULL;
/*----------------------------------------------------------Хѿޤ*/

/*-------------------------------------*/
#define iej_cquad4 40
#define iej_ctria3 30
#define iej_crod   20
#define iej_cbar   21
#define iej_cbeam  22
#define iej_chexa  80
#define iej_cpenta 60
#define iej_ctetra 45
#define iej_cshear 41

#define icord_r 1
#define icord_c 2

#define IGNORE 1
#define NO_IGNORE 0



/* ----------------------------- */
int 
smplChgCord_r2c(double  *x_def,double  *y_def)
/*
   ľɸϤɸϤѴ
   r:Ⱦ
   thi:[deg]
   Ⱦ=0ΤȤ=0
   ٤-180180ϰϤ֤
*/
{
   double r,thi;
   r=sqrt((*x_def)*(*x_def)+(*y_def)*(*y_def));
   if (r==0.0)           thi=0.0;
   else if (*y_def==0.0) thi=acos(*x_def/r);
   else                  thi=acos(*x_def/r)*fabs(*y_def)/(*y_def);
   thi=thi/3.14159265358979*180.0;
   *x_def=r;
   *y_def=thi;
   return 0;
}
/* ----------------------------- */
int 
smplChgCord_c2r(double  *x_def,double  *y_def)
/*
   ɸϤľɸϤѴ
*/
{
   double x_new,y_new;
   *y_def=*y_def/180.0*3.14159265358979;
   x_new=*x_def*cos(*y_def);
   y_new=*x_def*sin(*y_def);
   *x_def=x_new;
   *y_def=y_new;
   return 0;
}
/* ----------------------------- */
double 
getThita(double *x,double *y)
{
   double r,thi;
   r=sqrt((*x)*(*x)+(*y)*(*y));
   if (r==0.0) thi=0.0;
   else if (*y==0.0) thi=acos(*x/r);
   else thi=acos(*x/r)*fabs(*y)/(*y);
   return thi;
}
/* ----------------------------- */
int 
rotate_zDef(double *x,double *y,double thi0)
{
   double r,thi;
   r=sqrt((*x)*(*x)+(*y)*(*y));
   thi=getThita(x,y);
   thi=thi+thi0;
   *x=r*cos(thi);
   *y=r*sin(thi);
   return 0;
}

/* ----------------------------- */
int 
smplChgCord_rot(double  *x_def,double  *y_def,double  *z_def,
                struct RBVector vec)
{
   double x_new,y_new,z_new;
   x_new=*x_def*vec.lRB1+*y_def*vec.lRB2+*z_def*vec.lRB3;
   y_new=*x_def*vec.mRB1+*y_def*vec.mRB2+*z_def*vec.mRB3;
   z_new=*x_def*vec.nRB1+*y_def*vec.nRB2+*z_def*vec.nRB3;
   *x_def=x_new;
   *y_def=y_new;
   *z_def=z_new;
   return(0);
}

/* ----------------------------- */
double 
det3x3(double a11,double a12,double a13,
       double a21,double a22,double a23,
       double a31,double a32,double a33)
{
   double det;
   det=a11*a22*a33+a21*a32*a13+a31*a12*a23
      -a21*a12*a33-a11*a32*a23-a31*a22*a13;
   return det;
}


/*----------------------------------------------------------*/
int 
sub_1vertShadowOn3Dplane(double x,double y,double z,
                         double a0,double b0,double c0,double d0,
                         double *x0,double *y0,double *z0)
/*
*-------------------------------------------------------------
*         vertex point             :    x,y,z
*         equation of 3Dplane      :    a0*x+b0*y+c0*z=d0
*         vertex shade on 3Dplane  :    x0,y0,z0
*-------------------------------------------------------------
*/
{

      double t0dwn,t0;
      t0dwn=1.0/(a0*a0+b0*b0+c0*c0);

      t0=-(a0*x+b0*y+c0*z+d0)*t0dwn;
      *x0=x+a0*t0;
      *y0=y+b0*t0;
      *z0=z+c0*t0;
      return(0);
}

/*----------------------------------------------------------*/
int 
smplChgCord_rot_rev(double  *x_new,double  *y_new,double  *z_new,
                    struct RBVector vec)
{
   double x_def,y_def,z_def;
   double det;
   det=det3x3(vec.lRB1,vec.lRB2,vec.lRB3,
              vec.mRB1,vec.mRB2,vec.mRB3,
              vec.nRB1,vec.nRB2,vec.nRB3);
   if (det==0.0) 
   {
      printf("ɽɸϤǤ\n");
      exit(1);
   }
   x_def=1/det*det3x3(*x_new  ,vec.lRB2,vec.lRB3,
                      *y_new  ,vec.mRB2,vec.mRB3,
                      *z_new  ,vec.nRB2,vec.nRB3);
   y_def=1/det*det3x3(vec.lRB1,*x_new  ,vec.lRB3,
                      vec.mRB1,*y_new  ,vec.mRB3,
                      vec.nRB1,*z_new  ,vec.nRB3);
   z_def=1/det*det3x3(vec.lRB1,vec.lRB2,*x_new  ,
                      vec.mRB1,vec.mRB2,*y_new  ,
                      vec.nRB1,vec.nRB2,*z_new  );
   *x_new=x_def;
   *y_new=y_def;
   *z_new=z_def;
   return(0);
}
/* ----------------------------- */
void 
chopSpace(char *buffer)
/*ʸ buffer Υڡ롣*/
{
   int i;
   if (strlen(buffer)<=0) return;
   for (i=0;i<=strlen(buffer);i++)
   {
      if (memcmp(buffer," ",1)==0) memcpy(buffer,buffer+1,strlen(buffer));
      else break;
   }
   for (i=strlen(buffer)-1;i>=0;i--)
   {
      if (memcmp(buffer+(size_t)i," ",1)==0||memcmp(buffer+(size_t)i,"\0",1)==0||
          memcmp(buffer+(size_t)i,"\n",1)==0)
          memcpy(buffer+(size_t)i,"\0",1);
      else break;
   }
}

/*----------------------------------------------------------*/
void 
d_heap_sort(int n,double ra[],double rb[])
/*
   ra򾮤¤ؤ롣
   rbб¤ؤ롣
   1ϤޤǤΤȤ롣
*/
{
   int l,j,ir,i;
   double rra,rrb;
   
   l=(n>>1)+1;
   ir=n;
   for (;;) 
   {
      if (l>1)
      {
         rra=ra[--l];
         rrb=rb[l];
      }
      else
      {
         rra=ra[ir];
         rrb=rb[ir];
         ra[ir]=ra[1];
         rb[ir]=rb[1];
         if (--ir==1)
         {
            ra[1]=rra;
            rb[1]=rrb;
            return;
         }
      }
      i=l;
      j=l << 1;
      while (j<=ir)
      {
         if (j<ir&&ra[j]<ra[j+1]) ++j;
         if (rra<ra[j])
         {
            ra[i]=ra[j];
            rb[i]=rb[j];
            j += (i=j);
         }
         else j=ir+1;
      }
      ra[i]=rra;
      rb[i]=rrb;
   }
}

/*----------------------------------------------------------*/
void 
i_heap_sort(int n,int ra[],int rb[])
/*
   ra򾮤¤ؤ롣
   rbб¤ؤ롣
   1ϤޤǤΤȤ롣
*/
{
   int l,j,ir,i;
   int rra,rrb;
   
   l=(n>>1)+1;
   ir=n;
   for (;;) 
   {
      if (l>1)
      {
         rra=ra[--l];
         rrb=rb[l];
      }
      else
      {
         rra=ra[ir];
         rrb=rb[ir];
         ra[ir]=ra[1];
         rb[ir]=rb[1];
         if (--ir==1)
         {
            ra[1]=rra;
            rb[1]=rrb;
            return;
         }
      }
      i=l;
      j=l << 1;
      while (j<=ir)
      {
         if (j<ir&&ra[j]<ra[j+1]) ++j;
         if (rra<ra[j])
         {
            ra[i]=ra[j];
            rb[i]=rb[j];
            j += (i=j);
         }
         else j=ir+1;
      }
      ra[i]=rra;
      rb[i]=rrb;
   }
}



/*----------------------------------------------------------*/
double 
maxf(double i,double j)
{
   double k;
   if (i>j) {k=i;}
       else {k=j;}
   return(k);
}

double 
minf(double i,double j)
{
   double k;
   if (i<j) {k=i;}
       else {k=j;}
   return(k);
}



/*----------------------------------------------------------*/
int 
realloc_elem(int *mNodeParm)
{
   *mNodeParm=*mNodeParm*1.5+1000;
   mid=(int *)realloc(mid,(*mNodeParm+1)*sizeof(int));
   pid=(int *)realloc(pid,(*mNodeParm+1)*sizeof(int));
   ie=(int (*)[9])realloc(ie,(*mNodeParm+1)*sizeof(*ie));
   iej=(int *)realloc(iej,(*mNodeParm+1)*sizeof(int));
   if (mid==NULL||pid==NULL||ie==NULL||iej==NULL) 
   {fprintf(stderr,"꤬­Ƥޤ\n");exit(1);}
   return 0;
}


int 
realloc_prop(int *pNodeParm)
{
   *pNodeParm=*pNodeParm*1.5+100;
   prop_id=(int *)realloc(prop_id,(*pNodeParm+1)*sizeof(int));
   prop_mid=(int *)realloc(prop_mid,(*pNodeParm+1)*sizeof(int));
   prop_thk=(double *)realloc(prop_thk,(*pNodeParm+1)*sizeof(double));
   piej=(int *)realloc(piej,(*pNodeParm+1)*sizeof(int));
   
   if (prop_id==NULL||prop_mid==NULL||prop_thk==NULL||piej==NULL) 
   {fprintf(stderr,"꤬­Ƥޤ\n");exit(1);}
   return 0;
}

int 
realloc_mat(int *maNodeParm)
{
   *maNodeParm=*maNodeParm*1.5+100;
   mat_id=(int *)realloc(mat_id,(*maNodeParm+1)*sizeof(int));
   mat_e=(double *)realloc(mat_e,(*maNodeParm+1)*sizeof(double));
   
   if (mat_id==NULL||mat_e==NULL) 
   {fprintf(stderr,"꤬­Ƥޤ\n");exit(1);}
   return 0;
}


/*----------------------------------------------------------*/
int 
mkRotateBox(struct CVector c_cvec,struct RBVector *c_rvec,int id)
{
   struct CVector vec;
   struct RBVector rvec;
   double a,r,delta,delta2;
   double xtmp,ytmp,ztmp,thi;
   int imode;
   
   vec.x[2]=c_cvec.x[2]-c_cvec.x[1];
   vec.x[3]=c_cvec.x[3]-c_cvec.x[1];
   vec.y[2]=c_cvec.y[2]-c_cvec.y[1];
   vec.y[3]=c_cvec.y[3]-c_cvec.y[1];
   vec.z[2]=c_cvec.z[2]-c_cvec.z[1];
   vec.z[3]=c_cvec.z[3]-c_cvec.z[1];
   
   c_rvec->lRB3=vec.x[2];
   c_rvec->mRB3=vec.y[2];
   c_rvec->nRB3=vec.z[2];
   if (c_rvec->lRB3!=0.0) a=vec.x[3]/(c_rvec->lRB3);
   else if (c_rvec->mRB3!=0.0) a=vec.y[3]/(c_rvec->mRB3);
   else if (c_rvec->nRB3!=0.0) a=vec.z[3]/(c_rvec->nRB3);
   else 
   {
      /*Z٥ȥĹ0*/
      printf("ɽɸ%dǤ\n",id);
      exit(1);
   }
   if (  c_rvec->lRB3*a==vec.x[3]
       &&c_rvec->mRB3*a==vec.y[3]
       &&c_rvec->nRB3*a==vec.z[3])
   {
      /*X٥ȥZ٥ȥ*/
      printf("ɽɸ%dǤ\n",id);
      exit(1);
   }
   /*x,y٥ȥ*/
   c_rvec->lRB2=vec.y[2]*vec.z[3]-vec.z[2]*vec.y[3];
   c_rvec->mRB2=vec.z[2]*vec.x[3]-vec.x[2]*vec.z[3];
   c_rvec->nRB2=vec.x[2]*vec.y[3]-vec.y[2]*vec.x[3];
   c_rvec->lRB1=vec.y[2]*c_rvec->nRB2-vec.z[2]*c_rvec->mRB2;
   c_rvec->mRB1=vec.z[2]*c_rvec->lRB2-vec.x[2]*c_rvec->nRB2;
   c_rvec->nRB1=vec.x[2]*c_rvec->mRB2-vec.y[2]*c_rvec->lRB2;
   /*٥ȥΥ1ˤ*/
   r=sqrt(c_rvec->lRB1*c_rvec->lRB1+c_rvec->mRB1*c_rvec->mRB1+c_rvec->nRB1*c_rvec->nRB1);
   c_rvec->lRB1=c_rvec->lRB1/r;
   c_rvec->mRB1=c_rvec->mRB1/r;
   c_rvec->nRB1=c_rvec->nRB1/r;
   r=sqrt(c_rvec->lRB2*c_rvec->lRB2+c_rvec->mRB2*c_rvec->mRB2+c_rvec->nRB2*c_rvec->nRB2);
   c_rvec->lRB2=c_rvec->lRB2/r;
   c_rvec->mRB2=c_rvec->mRB2/r;
   c_rvec->nRB2=c_rvec->nRB2/r;
   r=sqrt(c_rvec->lRB3*c_rvec->lRB3+c_rvec->mRB3*c_rvec->mRB3+c_rvec->nRB3*c_rvec->nRB3);
   c_rvec->lRB3=c_rvec->lRB3/r;
   c_rvec->mRB3=c_rvec->mRB3/r;
   c_rvec->nRB3=c_rvec->nRB3/r;
   /*٥ȥθ*/
   /*٥ȥ룱*/
   /*vec.?[3]l1,c_rvec->?RB3ذȤθ
   ˡ٥ȥc_rvec->?RB1*/
   sub_1vertShadowOn3Dplane(vec.x[3],vec.y[3],vec.z[3],
                            c_rvec->lRB1,c_rvec->mRB1,c_rvec->nRB1,0.0,
                            &xtmp,&ytmp,&ztmp);
   /*٥ȥvec.?[3]ȤΰִطӤ椬դʤ٥ȥž롣*/
   delta=vec.x[3]-xtmp;imode=1;
   if (fabs(delta)<fabs(vec.y[3]-ytmp)) {delta=vec.y[3]-ytmp;imode=2;}
   else if (fabs(delta)<fabs(vec.z[3]-ztmp)) {delta=vec.z[3]-ztmp;imode=3;}
   if ( (imode==1&&(delta*c_rvec->lRB1)<0.0)
      ||(imode==2&&(delta*c_rvec->mRB1)<0.0)
      ||(imode==3&&(delta*c_rvec->nRB1)<0.0))
   {
      c_rvec->lRB1=-c_rvec->lRB1;
      c_rvec->mRB1=-c_rvec->mRB1;
      c_rvec->nRB1=-c_rvec->nRB1;
   }
   /*٥ȥ룲*/
   rvec.lRB1=c_rvec->lRB1;rvec.mRB1=c_rvec->mRB1;rvec.nRB1=c_rvec->nRB1;
   rvec.lRB2=c_rvec->lRB2;rvec.mRB2=c_rvec->mRB2;rvec.nRB2=c_rvec->nRB2;
   rvec.lRB3=c_rvec->lRB3;rvec.mRB3=c_rvec->mRB3;rvec.nRB3=c_rvec->nRB3;
   /*٥ȥ1xyʿ̤ǲž*/
   thi=getThita(&rvec.lRB1,&rvec.mRB1);
   rotate_zDef(&rvec.lRB1,&rvec.mRB1,-thi);
   rotate_zDef(&rvec.lRB2,&rvec.mRB2,-thi);
   rotate_zDef(&rvec.lRB3,&rvec.mRB3,-thi);
   /*٥ȥ1zxʿ̤ǲž*/
   thi=getThita(&rvec.lRB1,&rvec.nRB1);
   rotate_zDef(&rvec.lRB1,&rvec.nRB1,-thi);
   rotate_zDef(&rvec.lRB2,&rvec.nRB2,-thi);
   rotate_zDef(&rvec.lRB3,&rvec.nRB3,-thi);
   /*٥ȥ3yzʿ̤ǲž*/
   thi=getThita(&rvec.mRB3,&rvec.nRB3);
   rotate_zDef(&rvec.mRB1,&rvec.nRB1,-thi);
   rotate_zDef(&rvec.mRB2,&rvec.nRB2,-thi);
   rotate_zDef(&rvec.mRB3,&rvec.nRB3,-thi);
   /*٥ȥ2åʤ鸵٥ȥȿž*/
   if (rvec.mRB2<0.0) 
   {
      c_rvec->lRB2=-c_rvec->lRB2;
      c_rvec->mRB2=-c_rvec->mRB2;
      c_rvec->nRB2=-c_rvec->nRB2;
   }
   return 0;
}

/*----------------------------------------------------------*/
int 
chgcordDifinition(int cnax)
/*ƤζɽɸϤλȺɸϤκɸ(cid=0)Ѵ롣*/
{
   int i,j,k,l;
   
   k=0;
   l=0;
   for (i=1;i<=cnax;i++)
   {
      if (ic3[i]==0) {mkRotateBox(c_cvec[i],&c_rvec[i],cid[i]);k++;continue;}
      for (j=1;j<=cnax;j++)
      {
         if (i==j) continue;
         if (ic3[i]==cid[j]) 
         {
            /*if (ic3[j]!=0) break;*/
            l++;
            if (ctype[j]==type_cylinder&&i_c_chgd[i]==0) 
            /*
               ٤ǤɸѴ餽ΥǡϱɸϤᤵʤᡢ
               ٺɸѴǡsmplChgCord_c2rϤƤϤʤ
            */
            {
               smplChgCord_c2r(&c_cvec[i].x[1],&c_cvec[i].y[1]);
               smplChgCord_c2r(&c_cvec[i].x[2],&c_cvec[i].y[2]);
               smplChgCord_c2r(&c_cvec[i].x[3],&c_cvec[i].y[3]);
            }
            i_c_chgd[i]=1;
            smplChgCord_rot_rev(&c_cvec[i].x[1],&c_cvec[i].y[1],&c_cvec[i].z[1],c_rvec[j]);
            smplChgCord_rot_rev(&c_cvec[i].x[2],&c_cvec[i].y[2],&c_cvec[i].z[2],c_rvec[j]);
            smplChgCord_rot_rev(&c_cvec[i].x[3],&c_cvec[i].y[3],&c_cvec[i].z[3],c_rvec[j]);
            c_cvec[i].x[1]=c_cvec[i].x[1]+c_cvec[j].x[1];
            c_cvec[i].x[2]=c_cvec[i].x[2]+c_cvec[j].x[2];
            c_cvec[i].x[3]=c_cvec[i].x[3]+c_cvec[j].x[3];
            c_cvec[i].y[1]=c_cvec[i].y[1]+c_cvec[j].y[1];
            c_cvec[i].y[2]=c_cvec[i].y[2]+c_cvec[j].y[2];
            c_cvec[i].y[3]=c_cvec[i].y[3]+c_cvec[j].y[3];
            c_cvec[i].z[1]=c_cvec[i].z[1]+c_cvec[j].z[1];
            c_cvec[i].z[2]=c_cvec[i].z[2]+c_cvec[j].z[2];
            c_cvec[i].z[3]=c_cvec[i].z[3]+c_cvec[j].z[3];
            if (cid[j]==0) mkRotateBox(c_cvec[i],&c_rvec[i],cid[i]);
         }
      }
   }
   if (k!=cnax&&l==0) 
   {
      printf("ɽɸϤǤʲκɸϤǧǤޤǤ\n");
      j=0;
      for (i=1;i<=cnax;i++)
      {
         if (ic3[i]!=0) {printf(" %d",ic3[i]);j++;}
         if (j==5) {printf("\n");j=0;}
      }
      if (j>0) printf("\n");
      exit(1);
   }
   
   return 0;
}

/*----------------------------------------------------------*/
int 
addBasicCords(int *cnax)
/*
   ɸ0ڤ1ɲä
*/
{
   *cnax=*cnax+1;
   cid[*cnax]=0;
   ic3[*cnax]=0;
   ctype[*cnax]=type_cartesian;
   i_c_chgd[*cnax]=0;
   c_cvec[*cnax].x[1]= 0.0;c_cvec[*cnax].y[1]= 0.0;c_cvec[*cnax].z[1]= 0.0;
   c_cvec[*cnax].x[2]= 0.0;c_cvec[*cnax].y[2]= 0.0;c_cvec[*cnax].z[2]= 1.0;
   c_cvec[*cnax].x[3]= 1.0;c_cvec[*cnax].y[3]= 0.0;c_cvec[*cnax].z[3]= 0.0;
   mkRotateBox(c_cvec[*cnax],&c_rvec[*cnax],cid[*cnax]);
   
   *cnax=*cnax+1;
   cid[*cnax]=1;
   ic3[*cnax]=0;
   ctype[*cnax]=type_cylinder;
   i_c_chgd[*cnax]=0;
   c_cvec[*cnax].x[1]= 0.0;c_cvec[*cnax].y[1]= 0.0;c_cvec[*cnax].z[1]= 0.0;
   c_cvec[*cnax].x[2]= 0.0;c_cvec[*cnax].y[2]= 0.0;c_cvec[*cnax].z[2]= 1.0;
   c_cvec[*cnax].x[3]= 1.0;c_cvec[*cnax].y[3]= 0.0;c_cvec[*cnax].z[3]= 0.0;
   mkRotateBox(c_cvec[*cnax],&c_rvec[*cnax],cid[*cnax]);
   
   return 0;
}

/*----------------------------------------------------------*/
int 
Creadnas(FILE *fin,int *nax,int *mx,int *cnax,int *ip,int *im,
         int *kNodeParm,int *mNodeParm,int *pNodeParm,int *maNodeParm)
{
   char tmpChar[256];
   char infile[256],newline[256];
   double r,r2,thi;
   while(1)
   {
      strcpy(newline,"");
      if (fgets(infile,sizeof infile,fin)==NULL) break;
      if (memcmp(infile,"CORD2R  ",8)==0
        ||memcmp(infile,"CORD2C  ",8)==0)
      {
         if (*cnax==0)
         {
            cid=(int *)realloc(cid,(MAXCORDID+1)*sizeof(int));
            ic3=(int *)realloc(ic3,(MAXCORDID+1)*sizeof(int));
            ctype=(int *)realloc(ctype,(MAXCORDID+1)*sizeof(int));
            i_c_chgd=(int *)realloc(i_c_chgd,(MAXCORDID+1)*sizeof(int));
            c_cvec=realloc(c_cvec,(MAXCORDID+1)*sizeof(*c_cvec));
            c_rvec=realloc(c_rvec,(MAXCORDID+1)*sizeof(*c_rvec));
            addBasicCords(cnax);
         }
         *cnax=*cnax+1;
         if (*cnax>=MAXCORDID) 
         {
            printf("ɽɸϤο%dĶޤ\n",MAXCORDID);
            exit(1);
         }
         if (memcmp(infile,"CORD2R  ",8)==0) ctype[*cnax]=type_cartesian;
         else                                ctype[*cnax]=type_cylinder;
         i_c_chgd[*cnax]=0;
         memcpy(tmpChar,infile+ 8,8);memcpy(tmpChar+8,"\0",1);cid[*cnax] =atoi(tmpChar);
         memcpy(tmpChar,infile+16,8);memcpy(tmpChar+8,"\0",1);ic3[*cnax] =atoi(tmpChar);
         memcpy(tmpChar,infile+24,8);memcpy(tmpChar+8,"\0",1);c_cvec[*cnax].x[1]=atof(tmpChar);
         memcpy(tmpChar,infile+32,8);memcpy(tmpChar+8,"\0",1);c_cvec[*cnax].y[1]=atof(tmpChar);
         memcpy(tmpChar,infile+40,8);memcpy(tmpChar+8,"\0",1);c_cvec[*cnax].z[1]=atof(tmpChar);
         memcpy(tmpChar,infile+48,8);memcpy(tmpChar+8,"\0",1);c_cvec[*cnax].x[2]=atof(tmpChar);
         memcpy(tmpChar,infile+56,8);memcpy(tmpChar+8,"\0",1);c_cvec[*cnax].y[2]=atof(tmpChar);
         memcpy(tmpChar,infile+64,8);memcpy(tmpChar+8,"\0",1);c_cvec[*cnax].z[2]=atof(tmpChar);
         if (  fgets(infile,sizeof infile,fin)==NULL
             ||(memcmp(infile,"        ",8)!=0&&memcmp(infile,"+",1)!=0)) 
         {
            printf("ɽɸϤǤ(id=%d)\n",cid[*cnax]);
            exit(1);
         }
         if (cid[*cnax]==0||cid[*cnax]==1)
         {
            printf("ɸID=0,1κɸϡľڤӱˤͽ󤵤Ƥޤ\n");
            printf("եƤɸϤ̵뤷ޤ\n");
            *cnax=*cnax-1;
         }
         memcpy(tmpChar,infile+ 8,8);memcpy(tmpChar+8,"\0",1);c_cvec[*cnax].x[3]=atof(tmpChar);
         memcpy(tmpChar,infile+16,8);memcpy(tmpChar+8,"\0",1);c_cvec[*cnax].y[3]=atof(tmpChar);
         memcpy(tmpChar,infile+24,8);memcpy(tmpChar+8,"\0",1);c_cvec[*cnax].z[3]=atof(tmpChar);
      }
      if (memcmp(infile,"GRID    ",8)==0) 
      {
         *nax=*nax+1;
         if (*nax>=*kNodeParm)
         {
            *kNodeParm=*kNodeParm*1.5+1000;
            id=(int *)realloc(id,(*kNodeParm+1)*sizeof(int));
            ic1=(int *)realloc(ic1,(*kNodeParm+1)*sizeof(int));
            ic2=(int *)realloc(ic2,(*kNodeParm+1)*sizeof(int));
            x=(double *)realloc(x,(*kNodeParm+1)*sizeof(double));
            y=(double *)realloc(y,(*kNodeParm+1)*sizeof(double));
            z=(double *)realloc(z,(*kNodeParm+1)*sizeof(double));
            if (id==NULL||ic1==NULL||ic2==NULL||x==NULL||y==NULL||z==NULL)
            {fprintf(stderr,"꤬­Ƥޤ\n");exit(1);}
         }
         memcpy(tmpChar,infile+ 8,8);memcpy(tmpChar+8,"\0",1);id[*nax] =atoi(tmpChar);
         memcpy(tmpChar,infile+16,8);memcpy(tmpChar+8,"\0",1);ic1[*nax]=atoi(tmpChar);
         memcpy(tmpChar,infile+24,8);memcpy(tmpChar+8,"\0",1);x[*nax]  =atof(tmpChar);
         memcpy(tmpChar,infile+32,8);memcpy(tmpChar+8,"\0",1);y[*nax]  =atof(tmpChar);
         memcpy(tmpChar,infile+40,8);memcpy(tmpChar+8,"\0",1);z[*nax]  =atof(tmpChar);
         memcpy(tmpChar,infile+48,8);memcpy(tmpChar+8,"\0",1);ic2[*nax]=atoi(tmpChar);
      }
      if (memcmp(infile,"CQUAD4  ",8)==0
        ||memcmp(infile,"CSHEAR  ",8)==0)
      {
         *mx=*mx+1;
         if (*mx>=*mNodeParm) realloc_elem(mNodeParm);
         iej[*mx]=iej_cquad4;
         memcpy(tmpChar,infile+ 8,8);memcpy(tmpChar+8,"\0",1);mid[*mx]  =atoi(tmpChar);
         memcpy(tmpChar,infile+16,8);memcpy(tmpChar+8,"\0",1);pid[*mx]  =atoi(tmpChar);
         memcpy(tmpChar,infile+24,8);memcpy(tmpChar+8,"\0",1);ie[*mx][1]=atoi(tmpChar);
         memcpy(tmpChar,infile+32,8);memcpy(tmpChar+8,"\0",1);ie[*mx][2]=atoi(tmpChar);
         memcpy(tmpChar,infile+40,8);memcpy(tmpChar+8,"\0",1);ie[*mx][3]=atoi(tmpChar);
         memcpy(tmpChar,infile+48,8);memcpy(tmpChar+8,"\0",1);ie[*mx][4]=atoi(tmpChar);
      }
      if (memcmp(infile,"CTRIA3  ",8)==0)
      {
         *mx=*mx+1;
         if (*mx>=*mNodeParm) realloc_elem(mNodeParm);
         iej[*mx]=iej_ctria3;
         memcpy(tmpChar,infile+ 8,8);memcpy(tmpChar+8,"\0",1);mid[*mx]  =atoi(tmpChar);
         memcpy(tmpChar,infile+16,8);memcpy(tmpChar+8,"\0",1);pid[*mx]  =atoi(tmpChar);
         memcpy(tmpChar,infile+24,8);memcpy(tmpChar+8,"\0",1);ie[*mx][1]=atoi(tmpChar);
         memcpy(tmpChar,infile+32,8);memcpy(tmpChar+8,"\0",1);ie[*mx][2]=atoi(tmpChar);
         memcpy(tmpChar,infile+40,8);memcpy(tmpChar+8,"\0",1);ie[*mx][3]=atoi(tmpChar);
      }
      if (memcmp(infile,"CROD    ",8)==0)
      {
         *mx=*mx+1;
         if (*mx>=*mNodeParm) realloc_elem(mNodeParm);
         iej[*mx]=iej_crod;
         memcpy(tmpChar,infile+ 8,8);memcpy(tmpChar+8,"\0",1);mid[*mx]  =atoi(tmpChar);
         memcpy(tmpChar,infile+16,8);memcpy(tmpChar+8,"\0",1);pid[*mx]  =atoi(tmpChar);
         memcpy(tmpChar,infile+24,8);memcpy(tmpChar+8,"\0",1);ie[*mx][1]=atoi(tmpChar);
         memcpy(tmpChar,infile+32,8);memcpy(tmpChar+8,"\0",1);ie[*mx][2]=atoi(tmpChar);
      }
      if (memcmp(infile,"CBAR    ",8)==0)
      {
         *mx=*mx+1;
         if (*mx>=*mNodeParm) realloc_elem(mNodeParm);
         iej[*mx]=iej_cbar;
         memcpy(tmpChar,infile+ 8,8);memcpy(tmpChar+8,"\0",1);mid[*mx]  =atoi(tmpChar);
         memcpy(tmpChar,infile+16,8);memcpy(tmpChar+8,"\0",1);pid[*mx]  =atoi(tmpChar);
         memcpy(tmpChar,infile+24,8);memcpy(tmpChar+8,"\0",1);ie[*mx][1]=atoi(tmpChar);
         memcpy(tmpChar,infile+32,8);memcpy(tmpChar+8,"\0",1);ie[*mx][2]=atoi(tmpChar);
      }
      if (memcmp(infile,"CBEAM   ",8)==0)
      {
         *mx=*mx+1;
         if (*mx>=*mNodeParm) realloc_elem(mNodeParm);
         iej[*mx]=iej_cbeam;
         memcpy(tmpChar,infile+ 8,8);memcpy(tmpChar+8,"\0",1);mid[*mx]  =atoi(tmpChar);
         memcpy(tmpChar,infile+16,8);memcpy(tmpChar+8,"\0",1);pid[*mx]  =atoi(tmpChar);
         memcpy(tmpChar,infile+24,8);memcpy(tmpChar+8,"\0",1);ie[*mx][1]=atoi(tmpChar);
         memcpy(tmpChar,infile+32,8);memcpy(tmpChar+8,"\0",1);ie[*mx][2]=atoi(tmpChar);
      }
      if (memcmp(infile,"PSHELL  ",8)==0
        ||memcmp(infile,"PSHEAR  ",8)==0
        ||memcmp(infile,"PROD    ",8)==0
        ||memcmp(infile,"PBAR    ",8)==0
        ||memcmp(infile,"PBEAM   ",8)==0
        ||memcmp(infile,"PSOLID  ",8)==0)
      {
         *ip=*ip+1;
         if (*ip>=*pNodeParm) realloc_prop(pNodeParm);
         memcpy(tmpChar,infile+ 8,8);memcpy(tmpChar+8,"\0",1);prop_id[*ip] =atoi(tmpChar);
         memcpy(tmpChar,infile+16,8);memcpy(tmpChar+8,"\0",1);prop_mid[*ip]=atoi(tmpChar);
         piej[*ip]=0;
         if (memcmp(infile,"PSHELL  ",8)==0
           ||memcmp(infile,"PSHEAR  ",8)==0)
         {
            piej[*ip]=iej_cquad4;
            memcpy(tmpChar,infile+24,8);memcpy(tmpChar+8,"\0",1);prop_thk[*ip]=atof(tmpChar);
         }
      }
      if (memcmp(infile,"MAT1    ",8)==0)
      {
         *im=*im+1;
         if (*im>=*maNodeParm) realloc_mat(maNodeParm);
         memcpy(tmpChar,infile+ 8,8);memcpy(tmpChar+8,"\0",1);mat_id[*im]=atoi(tmpChar);
         memcpy(tmpChar,infile+16,8);memcpy(tmpChar+8,"\0",1);mat_e[*im] =atof(tmpChar);
      }
   }
   return 0;
}

/*---------------------------------*/
int 
geteffect(char *mystr)
{
   int i,is;
   chopSpace(mystr);
   is=strlen(mystr);
   for (i=1;i<=is;i++)
   {
      if (memcmp(mystr,"0",1)==0||
          memcmp(mystr,".",1)==0||
          memcmp(mystr,"-",1)==0||
          memcmp(mystr,"+",1)==0
         ) memcpy(mystr,mystr+1,strlen(mystr)+1);
      else break;
      
   }
   return 0;
}


/*---------------------------------*/
int 
write8f(FILE *fout,double val)
{
   char tmpChar[256],tmpChar2[256];
   int i;
   sprintf(tmpChar,"%f",val);
   if (strlen(tmpChar)<=8) 
   {
      strcpy(tmpChar2,"        ");
      memcpy(tmpChar2+8-strlen(tmpChar),tmpChar,strlen(tmpChar));
      fprintf(fout,"%s",tmpChar2);
      return 0;
   }
   /*---*/
   memcpy(tmpChar+8,"\0",1);
   if (strstr(tmpChar,".")!=NULL) 
   {
	  strcpy(tmpChar2,tmpChar);
	  geteffect(tmpChar2);
	  if (strlen(tmpChar2)>=3)
	  {
         fprintf(fout,"%s",tmpChar);
         return 0;
      }
   }
   /*-----------------*/
   sprintf(tmpChar,"%e",val);
   if (strlen(tmpChar)<=8) 
   {
      strcpy(tmpChar2,"        ");
      memcpy(tmpChar2+8-strlen(tmpChar),tmpChar,strlen(tmpChar));
      fprintf(fout,"%s",tmpChar2);
      return 0;
   }
   /*---*/
   for (i=0;i<strlen(tmpChar);i++)
   {
      if (memcmp(tmpChar+(size_t)i,"e",1)==0)
      {
         while(1)
         {
            if (memcmp(tmpChar+(size_t)i+2,"0",1)==0) memcpy(tmpChar+(size_t)i+2,tmpChar+(size_t)i+3,100);
            else break;
         }
         memcpy(tmpChar+8-(strlen(tmpChar)-(size_t)i),tmpChar+(size_t)i,strlen(tmpChar)-(size_t)i+1);
         fprintf(fout,"%s",tmpChar);
         return 0;
      }
   }
   return 0;
}
/*------------------------------------------------------*/
int 
cordchk_out(int cnax)
{
   FILE *fout;
   int i;
   fout=fopen("__tmp_checkChangedCoordinates.dat","wt");
   if (fout==NULL) 
   {
      printf("ɸϽϥեκ˼Ԥޤ\n");
      exit(1);
   }
   for (i=1;i<=cnax;i++)
   {
      if (ctype[i]==type_cartesian) fprintf(fout,"CORD2R  ");
      else if (ctype[i]==type_cylinder) fprintf(fout,"CORD2C  ");
      fprintf(fout,"%8d%8d",cid[i]+90000000,ic3[i]);
      write8f(fout,c_cvec[i].x[1]);
      write8f(fout,c_cvec[i].y[1]);
      write8f(fout,c_cvec[i].z[1]);
      write8f(fout,c_rvec[i].lRB3+c_cvec[i].x[1]);
      write8f(fout,c_rvec[i].mRB3+c_cvec[i].y[1]);
      write8f(fout,c_rvec[i].nRB3+c_cvec[i].z[1]);
      fprintf(fout,"+       \n+       ");
      write8f(fout,c_rvec[i].lRB1+c_cvec[i].x[1]);
      write8f(fout,c_rvec[i].mRB1+c_cvec[i].y[1]);
      write8f(fout,c_rvec[i].nRB1+c_cvec[i].z[1]);
      fprintf(fout,"\n");
      /*
      printf("%f %f %f\n",c_rvec[i].lRB1,c_rvec[i].mRB1,c_rvec[i].nRB1);
      printf("%f %f %f\n",c_rvec[i].lRB2,c_rvec[i].mRB2,c_rvec[i].nRB2);
      printf("%f %f %f\n",c_rvec[i].lRB3,c_rvec[i].mRB3,c_rvec[i].nRB3);
      */
   }
   fclose(fout);
   return 0;
}
/*------------------------------------------------------*/


/*------------------------------------------------------*/
int 
i_findval(int mx,int eid0)
{
   int i,ic;
   int i_high=mx,i_low=1;
   
   if (mid[1]==eid0) return 1;
   if (mid[mx]==eid0) return mx;
   
   while(1)
   {
      if (i_high-i_low>100)
      {
         ic=(i_high+i_low)/2;
         if (mid[ic]==eid0) return ic;
         if (mid[ic]>eid0) i_high=ic;
         else              i_low=ic;
      }
      else
      {
         for (i=i_low;i<=i_high;i++) if (mid[i]==eid0) return i;
         printf("%dϥǥ˴ޤޤޤ\n",eid0);
         return 0;/*eid0˴ޤޤʤ0֤*/
      }
   }
   return 0;
}


/*------------------------------------------------------*/
int 
writeuniv_2411(FILE *fout,int nax,int *id, double *x,double *y,double *z)
{
   int i;
   fprintf(fout,"   -1\n 2411\n");
   for (i=1;i<=nax;i++)
   {
      fprintf(fout," %d %d %d %d\n",id[i],0,0,0);
      fprintf(fout," %f %f %f\n",x[i],y[i],z[i]);
   }
   fprintf(fout,"   -1\n\n");
   return 0;
}

/*------------------------------------------------------*/
int 
writeuniv_2412(FILE *fout,int mx,int ip, int i_mode_ignore_bar)
{
   int i,j,m;
   int m_iej;
   fprintf(fout,"   -1\n 2412\n");
   
   /*p_taiouϥХѿ*/
   p_taiou=(int *)realloc(p_taiou,(mx+1)*sizeof(int));
   if (p_taiou==NULL)
   {
      printf("꤬­Ƥޤuniversal fileνϤ˼Ԥޤ\n");
      exit(1);
   }
   p_taiou[0]=0;
   for (i=1;i<=mx;i++)
   {
      for (j=1;j<=ip;j++)
      {
         if (pid[i]==prop_id[j]) {p_taiou[i]=j;break;}
         if (j==ip) p_taiou[i]=0;
      }
   }
   
   
   for (m=1;m<=mx;m++)
   {
      if (iej[m]==iej_cquad4) m_iej=4;
      else if (iej[m]==iej_ctria3) m_iej=3;
      else if (  i_mode_ignore_bar==NO_IGNORE
               &&(iej[m]==iej_crod||iej[m]==iej_cbar||iej[m]==iej_cbeam)) {m_iej=3;ie[m][3]=ie[m][2];}
      else continue;
      fprintf(fout," %d %d %d %d %d %d\n",mid[m],0,pid[m],prop_mid[p_taiou[m]],0,m_iej);
      for (i=1;i<=m_iej;i++) fprintf(fout,"%d ",ie[m][i]);
      fprintf(fout,"\n");
   }
   
   fprintf(fout,"   -1\n\n");
   return 0;
}

/*------------------------------------------------------*/
int 
chgGridCord(int nax,int cnax)
{
   int i,k;
   
   for(i=1;i<=nax;i++)
   {
      if (ic1[i]!=0)
      {
         for (k=1;k<=cnax;k++)
         {
            if (cid[k]==ic1[i]) 
            {
               if (ctype[k]==type_cylinder) smplChgCord_c2r(&x[i],&y[i]);
               smplChgCord_rot_rev(&x[i],&y[i],&z[i],c_rvec[k]);
               x[i]=x[i]+c_cvec[k].x[1];
               y[i]=y[i]+c_cvec[k].y[1];
               z[i]=z[i]+c_cvec[k].z[1];
               ic1[i]=0;
               break;
            }
            if (k==cnax) 
            {
               printf("GRID%dȤƤɸ%dƤޤ\n",id[i],ic1[i]);
               exit(1);
            }
         }
      }
   }
   return 0;
}
/*------------------------------------------------------*/
int 
addUnv(char *outfile)
{
   int i,j;
   char tmpChar[256];
   for (i=strlen(outfile)-1;i>=0;i--)
   {
      if (memcmp(outfile+(size_t)i,".",1)==0)
      {
         memcpy(outfile+(size_t)i,"\0",1);
         break;
      }
   }
   strcpy(tmpChar,outfile);
   sprintf(outfile,"%s.unv",tmpChar);
   return 0;
}
/*------------------------------------------------------*/
int 
chg_fname(char *outfile)
{
   int i,j;
   char tmpChar[256];
   for (i=strlen(outfile)-1;i>=0;i--)
   {
      if (memcmp(outfile+(size_t)i,".",1)==0)
      {
         memcpy(outfile+(size_t)i,"\0",1);
         break;
      }
   }
   strcpy(tmpChar,outfile);
   sprintf(outfile,"%s_prop.res",tmpChar);
   return 0;
}
/*------------------------------------------------------*/
int 
write_res_prop(FILE *fout,int mx,int ip,int im,int i_mode_ignore_bar)
{
   int i,j,mmx=0;
   int *m_taiou=NULL;
   m_taiou=(int *)realloc(m_taiou,(ip+1)*sizeof(int));
   if (m_taiou==NULL)
   {
      printf("꤬­ƤޤpropertyνϤ˼Ԥޤ\n");
      exit(1);
   }
   m_taiou[0]=0;
   for (i=1;i<=ip;i++)
   {
      for (j=1;j<=im;j++)
      {
         if (prop_mid[i]==mat_id[j]) {m_taiou[i]=j;break;}
         if (j==im) m_taiou[i]=0;
      }
   }
   /*ץѥƥƤʤ硢ĸ-1Ȥ롣*/
   prop_thk[0]=-1.0;
   mat_e[0]=-1.0;
   
   
   fprintf(fout,"BEGIN FIELD\n");
   fprintf(fout,"CUSTOM_MENU 0 0 0 0 0\n");
   fprintf(fout,"6  PROP_ID   property ID\n");
   fprintf(fout,"7  MAT_ID    material ID\n");
   fprintf(fout,"8  SHELL_THK shell thickness\n");
   fprintf(fout,"9  MAT_ELAS  elastic module\n");
   fprintf(fout,"ENDOF FIELD\n\n");
   
   
   for (i=1;i<=mx;i++) 
   {
      if (i_mode_ignore_bar==NO_IGNORE
        ||(iej[i]==iej_cquad4||iej[i]==iej_ctria3||iej[i]==iej_chexa)) mmx++;
   }
   /*--------------------------------------------pid*/
   fprintf(fout,"BEGIN FIELD\n");
   fprintf(fout,"PROP_ID   0 0 0 1 %d\n",mmx);
   for (i=1;i<=mx;i++)
   {
      if (i_mode_ignore_bar==NO_IGNORE
       ||(iej[i]==iej_cquad4||iej[i]==iej_ctria3||iej[i]==iej_chexa)) 
      {
         fprintf(fout,"    %d    %f\n",mid[i],(double)pid[i]);
      }
   }
   fprintf(fout,"ENDOF FIELD\n\n");
   
   /*--------------------------------------------matID*/
   fprintf(fout,"BEGIN FIELD\n");
   fprintf(fout,"MAT_ID   0 0 0 1 %d\n",mmx);
   for (i=1;i<=mx;i++)
   {
      if ((iej[i]==iej_cquad4||iej[i]==iej_ctria3||iej[i]==iej_chexa) 
        &&(p_taiou[i]<=ip))
      {
         fprintf(fout,"    %d    %f\n",mid[i],(double)prop_mid[p_taiou[i]]);
      }
      else if (i_mode_ignore_bar==NO_IGNORE) fprintf(fout,"    %d    %f\n",mid[i],0.0);
   }
   fprintf(fout,"ENDOF FIELD\n\n");
   
   /*--------------------------------------------ĸ*/
   fprintf(fout,"BEGIN FIELD\n");
   fprintf(fout,"SHELL_THK   0 0 0 1 %d\n",mmx);
   for (i=1;i<=mx;i++)
   {
      if ((iej[i]==iej_cquad4||iej[i]==iej_ctria3||iej[i]==iej_chexa) 
        &&(p_taiou[i]<=ip))
      {
         fprintf(fout,"    %d    %f\n",mid[i],prop_thk[p_taiou[i]]);
      }
      else if (i_mode_ignore_bar==NO_IGNORE) fprintf(fout,"    %d    %f\n",mid[i],0.0);
   }
   fprintf(fout,"ENDOF FIELD\n\n");

   /*--------------------------------------------Ψ*/
   fprintf(fout,"BEGIN FIELD\n");
   fprintf(fout,"MAT_ELAS   0 0 0 1 %d\n",mmx);
   for (i=1;i<=mx;i++)
   {
      if ((iej[i]==iej_cquad4||iej[i]==iej_ctria3||iej[i]==iej_chexa) 
        &&(p_taiou[i]<=ip)&&(m_taiou[p_taiou[i]]<=im))
      {
         fprintf(fout,"    %d    %f\n",mid[i],mat_e[m_taiou[p_taiou[i]]]);
      }
      else if (i_mode_ignore_bar==NO_IGNORE) fprintf(fout,"    %d    %f\n",mid[i],0.0);
   }
   fprintf(fout,"ENDOF FIELD\n\n");
   
   free(p_taiou);
   free(m_taiou);
   return 0;
}

/*------------------------------------------------------*/
main(int argc,char **argv)
{
   char infile[256];
   char outfile[256],tmpChar[256];
   char tmp;
   int kNodeParm=0,mNodeParm=0,pNodeParm=0,maNodeParm=0;
   int nax,mx,cnax=0,ip,im;
   int i,j,k=0,iTmp;
   int i_mode_ignore_bar=IGNORE;
   FILE *fin;
   FILE *fout;
   fin=NULL;
   fout=NULL;
   
   
   if(argc!=2&&argc!=3)
   {
      fprintf(stderr,"nas2unv ver 0.5:desined by Yuuki Nagashima 2001.02.27\n\n");
      fprintf(stderr,"Usage: nas2unv nasfile\n");
      fprintf(stderr,"       nas2unv -b nasfile\n");
      fprintf(stderr,"nastranΥХ륯ǡեɹߡ˥СեѴ롣\n");
      fprintf(stderr,"ˡǤΥץѥƥIDIDĸڤӥΨꥶȥեν񼰤ǽϤ롣\n\n");
      fprintf(stderr,"Х륯ǡեϸեɥեޥå(8๽)Τб\n");
      fprintf(stderr,"-bꤷ硢CRODڤCBARɤ򵿻ѷǡ2,3");
      fprintf(stderr,"ˤȤƽϤ롣\n");
      fprintf(stderr,"ߤΤȤбƤ륫ɤϰʲ̤ꡣ\n");
      fprintf(stderr,"ڤӶɽɸϡ\nGRID, CORD2R, CORD2C\n");
      fprintf(stderr,"ǡ\nCQUAD4, CSHEAR, CTRIA3, CHEXA");
      fprintf(stderr,"-bץCROD, CBAR, CBEAM\n");
      fprintf(stderr,"\nMAT1\n");
      fprintf(stderr,"\nPSHELL,PSHEAR,PROD,PBAR,PBEAM,PSOLID\n");
      fprintf(stderr,"\n");
      exit(1);
    }
   
   if (strcmp(argv[1],"-b")==0)
   {
      if (argc!=3) 
      {printf("οǤ\n");exit(1);}
      i_mode_ignore_bar=NO_IGNORE;
      strcpy(infile,argv[2]);
      strcpy(outfile,infile);
      addUnv(outfile);
   }
   else
   {
      if (argc!=2) 
      {printf("οǤ\n");exit(1);}
      strcpy(infile,argv[1]);
      strcpy(outfile,infile);
      addUnv(outfile);
   }
   /*----------------------------------------------------------------------*/
   /*-------------------------------------NSATRANХ륯ǡեɹ*/
   fin=fopen(infile,"rt");
   if (fin==NULL) {printf("file open error:fin:%s\n",infile);exit(1) ;}
   nax=0;
   mx=0;
   ip=0;
   im=0;
   Creadnas(fin,&nax,&mx,&cnax,&ip,&im,&kNodeParm,&mNodeParm,&pNodeParm,&maNodeParm);
   printf("nax -> %d, mx -> %d\n",nax,mx);
   fclose(fin);
   chgcordDifinition(cnax);
   /*cordchk_out(cnax);*//*ѴɽɸϤNastranν񼰤ǤФ֥롼*/
   chgGridCord(nax,cnax);
   
   /*----------------------------------------------------------------------*/
   /*-------------------------------------------------Universalե*/
   printf("writing %s ...\n",outfile);
   fout=fopen(outfile,"wt");
   if (fout==NULL) {printf("file open error:fout:%s\n",outfile);exit(1) ;}
   
   writeuniv_2411(fout,nax,id,x,y,z);
   writeuniv_2412(fout,mx,ip,i_mode_ignore_bar);
   fclose(fout);
   
   /*----------------------------------------------------------------------*/
   /*---------------------------------------------ץѥƥresե*/
   chg_fname(outfile);
   printf("writing %s ...\n",outfile);
   fout=fopen(outfile,"wt");
   if (fout==NULL) {printf("file open error:fout:%s\n",outfile);exit(1) ;}
   write_res_prop(fout,mx,ip,im,i_mode_ignore_bar);
   fclose(fout);
   
   printf("program Terminated successfully.\n");
   return 0;
}
